#---------------------------------------------------------------------------
#
#   SuPy GUI - Modal Dialog - Cocoa
#
#---------------------------------------------------------------------------

from traceback import print_exc
from AppKit import NSApplication
from g_modal_dialog import GModalDialog

class ModalDialog(GModalDialog):

	def _present(self):
		ns_set_key_equiv(self.default_button, "\x0d")
		ns_set_key_equiv(self.cancel_button, "\x1b")
		try:
			NSApplication.sharedApplication().runModalForWindow_(self._ns_window)
		finally:
			#  Sketchup hangs if a window contains a button with Return as
			#  its keyboard equivalent while not running a modal event loop.
			ns_set_key_equiv(self.default_button, "")
	
	def _dismiss(self):
		NSApplication.sharedApplication().abortModal()

#---------------------------------------------------------------------------

def ns_set_key_equiv(button, code):
	if button:
		button._ns_view.setKeyEquivalent_(code)
